#!/usr/bin/python

import sys
import time
import difflib
import pigpio
import RPi.GPIO as GPIO
GPIO.setmode(GPIO.BCM)


RX=18
txEnable=17
#txValues = ["na","na","na"]
pwm       = -1
reflecton = -1
elapsed   = -1

GPIO.setup(txEnable,GPIO.OUT)

try:

	pi = pigpio.pi()
	pi.set_mode(RX, pigpio.INPUT)
	#pi.bb_serial_read_open(RX, 115200, 8)#get better results than 115200
	pi.bb_serial_read_open(RX, 118000, 8)#get better results than 115200

	print "DATA - SOFTWARE SERIAL:"

	while 1:
		GPIO.output(txEnable, False)
		time.sleep(1)
		print 'starting poll'
		GPIO.output(txEnable, True)
		notFound = True

		while notFound:
			(count, data) = pi.bb_serial_read(RX)
			if count:
				#txValues = ["na","na","na"]
				print data
				#try:
				txValues = data.split('|')
				pwm       = str('0x'+txValues[0])
				reflection = str('0x'+txValues[1])
				elapsed   = str('0x'+txValues[2])
				try:
					#pwm       = int('0x'+txValues[0], 16)
					#reflecton = int('0x'+txValues[1], 16)
					#elapsed   = int('0x'+txValues[2], 16)
					pwm       = int(pwm, 16)
					reflecton = int(reflection, 16)
					elapsed   = int(elapsed, 16)
					#print (int(pwm, 16))
					#print (int(reflection, 16))
					#print (int(elapsed, 16))
			
					if pwm is not None or reflection is not None or elapsed is not None:
						print "PWM Value:", pwm
						print "Reflection Count:", reflection
						print "Ms Elapsed:", elapsed
					notFound = False
				except:
					print 'failed transmittion'
				#print (int(pwm, 16))
				#print (int(reflection, 16))
				#print (int(elapsed, 16))
				


except:
	pi.bb_serial_read_close(RX)
	pi.stop()
