#!/usr/bin/env python

import RPi.GPIO as GPIO
import time

GPIO.setmode(GPIO.BCM)
'''
power=0
up=0
down=0
left=0
right=0
center=0
initialized = False
'''
def initializeButtons(newPower, newUp, newDown, newLeft, newRight, newCenter):
	
	power = newPower
	up    = newUp
	down  = newDown
	left  = newLeft
	right = newRight
	center= newCenter
	
	GPIO.setup(power, GPIO.IN, pull_up_down=GPIO.PUD_UP)
	GPIO.setup(up, GPIO.IN, pull_up_down=GPIO.PUD_UP)
	GPIO.setup(down, GPIO.IN, pull_up_down=GPIO.PUD_UP)
	GPIO.setup(left, GPIO.IN, pull_up_down=GPIO.PUD_UP)
	GPIO.setup(right, GPIO.IN, pull_up_down=GPIO.PUD_UP)
	GPIO.setup(center, GPIO.IN, pull_up_down=GPIO.PUD_UP)
	
	initialized = True

#only want to process one button at a time
def getButton(power, center, up, down, left, right):

	buttClicked = "NA"

	if (not GPIO.input(power)):
		buttClicked = "power"
	elif (not GPIO.input(center)):
		buttClicked = "center"
	elif (not GPIO.input(up)):
		buttClicked = "up"
	elif (not GPIO.input(down)):
		buttClicked = "down"
	elif (not GPIO.input(left)):
		buttClicked = "left"
	elif (not GPIO.input(right)):
		buttClicked = "right"
	else:
		buttClicked = "NA"

		
	return buttClicked
	

	

#while True:
#	var = getButton(21, 13, 16, 19, 20, 26)
#	if(var != "NA"):
#		print (var)
#	time.sleep(.1)

#need to find when i want to cleanup gpio
def cleanup():
	GPIO.cleanup()
